#include "playername.h"

cvar_t *mp_teamplay;

cvar_t *tfcspyfix;
cvar_t *r_p_time;
cvar_t *fastdetection;
 
cvar_t *enemy_color;
cvar_t *friendly_color;
cvar_t *dm_color;

cvar_t *team1_color;
cvar_t *team2_color;
cvar_t *team3_color;
cvar_t *team4_color;

cvar_t *op4ctf_enabled;
cvar_t *fixed_teams;

cvar_t *extra_info;

cvar_t *e_style1;
cvar_t *e_style2;
cvar_t *f_style1;
cvar_t *dmstyle1;

cvar_t *hud_fx;
cvar_t *hud_fadein;
cvar_t *hud_fadeout;
cvar_t *hud_hold;
cvar_t *hud_fxtime;

const t_color defEnemyColor	=	{230,53,0};
const t_color defFriendlyColor	=	{72,193,29};
const t_color defDMColor	=	{27,102,228};
const t_color defTeam3Color	=	{200,150,0};
const t_color NullColor		=	{0,0,0};

char	mod_name[32];
bool	default_showenemy_on	=	false;

float   NewRoundOffTime		=	0;
int	team_allies[4];
bool	is_defaultctf		=	false;

static float m_HudShowTime[33]	=	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

bool	TeamPlayIsOn		=	false;
bool	TeamPlayChecked		=	false;
edict_t	*pent_info_tfdetect	=	NULL;
int 	mod_id			=	0;
bool	IsFirstFrame		=	true;
float	NextHUDCvars_checktime  =	0;
bool    mp_teamplay_WasSetOnWorldSpawn= false;

cvar_t	*teamsystem 		= 	NULL;
cvar_t	*noteamcolor 		= 	NULL;
cvar_t	*pn_on			= 	NULL;
cvar_t	*tm_only		= 	NULL;
cvar_t	*teamforce 		= 	NULL;
cvar_t  *pystytaso		=	NULL;
cvar_t  *vaakataso		=	NULL;
cvar_t  *cvar_NewRoundOffTime	=	NULL;


static hudtextparms_t ResetHUD = { 	
 	0, //x
	0, //y
	1, //effect
	0,0,0,0,//color1
	0,0,0,0,//color2
	0.2,//FadeinTime
	0.1,//FadeoutTime
	0.75,//HoldTime
	0,//fxTime
	3 //Channel
};


static void ServerDeactivate(void)
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	is_defaultctf		= false;
	TeamPlayChecked		= false;
	TeamPlayIsOn		= false;
	IsFirstFrame		= true;
	pent_info_tfdetect	= NULL;
	
	RETURN_META(MRES_HANDLED);
}


//Resets 0,0,0 RGBs to default settings
static void PlayernameCVARThink(void)
{
	t_color tmp1;

	UTIL_GetColor(tmp1, color_Team1);
	UTIL_GetColor(tmp1, color_Team2);
	UTIL_GetColor(tmp1, color_Team3);
	UTIL_GetColor(tmp1, color_Team4);

	UTIL_GetColor(tmp1, color_Friendly);
	UTIL_GetColor(tmp1, color_Enemy);
	UTIL_GetColor(tmp1, color_DM);
	
	IsFirstFrame = false;
}


static void PlayerPostThink( edict_t *pThis )
{	
	//Multiplayer ONLY!
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	//Let's check if colors are not set yet!
	if (IsFirstFrame) PlayernameCVARThink();
	
	//update HUDReset with HUD-Config cvars every 1sec
	if (NextHUDCvars_checktime<gpGlobals->time)
	{
		ResetHUD.effect		= (byte)hud_fx->value;
		ResetHUD.fadeinTime	= hud_fadein->value;
		ResetHUD.fadeoutTime	= hud_fadeout->value;
		ResetHUD.holdTime	= hud_hold->value;
		ResetHUD.fxTime		= hud_fxtime->value;
		
		NextHUDCvars_checktime=gpGlobals->time + 1.0f;
	}

	//Let's check if this is teamplay!
	if (!TeamPlayChecked) CheckTeamPlay();
	
	//If "playername_on" is not "1" we'll return.
	//or If mod_id is 4 (op4) and we're running ctf-map with "playername_enabled_in_op4ctf" set to "0".
	if ((int)(pn_on->value)!=1 || (mod_id==4 && (is_defaultctf && ((int)(op4ctf_enabled->value))==0))) RETURN_META(MRES_IGNORED);
	
	if (mod_id==3)
	{
		if (NewRoundOffTime > gpGlobals->time)
			RETURN_META(MRES_IGNORED);
	}
	
	int pid = ENTINDEX(pThis);
	
	if (
		!IsValidIndex(pid)			//Of course this is ValidIndex! .. It's the player!
			|| 
		!IsAlive(pThis)				//Show playernames only for living players (?)
			||
		pThis->v.flags & FL_FAKECLIENT		//We don't want to generate client message for fake client (bot)
			|| 
		gpGlobals->time < m_HudShowTime[pid]	//Is it our turn or not?
	   )
	{
		RETURN_META(MRES_IGNORED);
	}
	
	//This is our target!	
	edict_t *pEntity = UTIL_FindEntityForward( pThis );
		
	if (
		pEntity==NULL				//Error?
			|| 
		!IsPlayer(pEntity)			//If our target is not player we'll return.
			||
		!IsAlive(pThis)				//If our target is dead we'll return.
	   )
	{
		RETURN_META(MRES_IGNORED);
	}
	
	//Target doesn't have name to be shown
	if ( !pEntity->v.netname || !(STRING(pEntity->v.netname))[0] )
	{
		RETURN_META(MRES_IGNORED);
	} 

	static char HUD_Text[MAX_HUD_TEXT_LENGTH];
		
	int teamsystem_value = ((int)teamsystem->value==100) ? mod_id : (int)teamsystem->value;
	int extrainfo = ((int)extra_info->value);

	//Spyfix .. check if target pretending to be on my team
	if(mod_id==2 && teamsystem_value==mod_id && (mod_name[0]=='t'||mod_name[0]=='T') && tfcspyfix->value>0)
	{
		if (pEntity->v.playerclass == TFC_CLASS_SPY && pThis->v.playerclass != TFC_CLASS_SPY && !Friendly_or_Enemy(teamsystem_value,pThis,pEntity))
		{
			//Yes .. it is enemy spy .. check if it is undercovering my team (code from HPB_Bot .. ty botman :] )
			char *infobuffer;
			char color[32];
			int color_bot, color_player;
			
			infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)( pEntity );
			STRNCPY(color, (g_engfuncs.pfnInfoKeyValue(infobuffer, "topcolor")), 32);
			color_bot = atoi( color );

			infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)( pThis );
			STRNCPY(color, (g_engfuncs.pfnInfoKeyValue(infobuffer, "topcolor")), 32);
			color_player = atoi( color );
			
			if (((color_bot==140) || (color_bot==148) || (color_bot==150) || (color_bot==153)) &&
				((color_player==140) || (color_player==148) || (color_player==150) || (color_player==153)))
				RETURN_META(MRES_IGNORED);

			if (((color_bot == 5) || (color_bot == 250) || (color_bot==255)) &&
				((color_player == 5) || (color_player == 250) || (color_player == 255)))
				RETURN_META(MRES_IGNORED);

			if ((color_bot == 45) && (color_player == 45))
				RETURN_META(MRES_IGNORED);

			if (((color_bot == 80) || (color_bot == 100)) &&
				((color_player == 80) || (color_player == 100)))
				RETURN_META(MRES_IGNORED);
		}
	}
		
	t_color TextColor;
	if ( (teamsystem_value > 0 && teamsystem_value < 5) && (TeamPlayIsOn || teamforce->value > 0) )
	{	
		//TeamPlay mode!
		if (Friendly_or_Enemy(teamsystem_value,pThis,pEntity))
		{
			//Friendly Target .. Show playername always!
			if (!GetTeamColor(teamsystem_value, pEntity, TextColor))
			{
				UTIL_GetColor(TextColor, color_Friendly);
			}
			
			GetFriendlyHudText(HUD_Text, MAX_HUD_TEXT_LENGTH, pEntity, extrainfo);
		}
		else
		{	
			//Enemy target! Checks if is ok to show enemy names.
			if ((int)(tm_only->value)==1)
			{
				//If only_teammate_value is 1, don't show enemy name!
				RETURN_META(MRES_IGNORED);
			}
			else
			{
				//If only_teammate_value is not 1 show enemy name!
				if (!GetTeamColor(teamsystem_value, pEntity, TextColor))
				{
					UTIL_GetColor(TextColor, color_Enemy);
				}
			}
			
			GetEnemyHudText(HUD_Text, MAX_HUD_TEXT_LENGTH, pEntity, extrainfo);
		}
	}
	else 
	{
		//DeathMatch mode!
		UTIL_GetColor(TextColor, color_DM);
		
		GetDMHudText(HUD_Text, MAX_HUD_TEXT_LENGTH, pEntity, extrainfo);
	}
	
	//Reset HUD
	hudtextparms_t tt_Parms = ResetHUD;
		
	//Set position
	tt_Parms.x=vaakataso->value;
	tt_Parms.y=pystytaso->value;
		
	//Set colors
	UTIL_SetHudParamColors(tt_Parms, TextColor);
		
	//Next playername show time
	m_HudShowTime[pid]=gpGlobals->time + tt_Parms.holdTime + tt_Parms.fadeoutTime + tt_Parms.fadeinTime;
		
	//Make sure that last one is null-char
	HUD_Text[MAX_HUD_TEXT_LENGTH-1]=0;
		
	//Print message to client
	UTIL_SendHudMessageOne( pThis , tt_Parms, HUD_Text );
		
	RETURN_META(MRES_HANDLED);
}


static int DispatchSpawn( edict_t *pent )
{	
	if (!gpGlobals->deathmatch) 
	{
		RETURN_META_VALUE(MRES_IGNORED, 0);
	}
	
	const char *pClassname = STRING(pent->v.classname);
	if (!stricmp(pClassname, "worldspawn"))
	{
		unsigned long i;
		for (i = 0; i < 4; i++)  team_allies[i] = 0;
		for (i = 0; i < 32; i++) m_HudShowTime[i] = gpGlobals->time;
		
		NewRoundOffTime = gpGlobals->time + cvar_NewRoundOffTime->value; //For CS
		NextHUDCvars_checktime = gpGlobals->time + 1.0f;
		
		mp_teamplay_WasSetOnWorldSpawn = (CVAR_GET_FLOAT("mp_teamplay") > 0);
   	}
	
	RETURN_META_VALUE(MRES_HANDLED, 0);
}


static void DispatchKeyValue( edict_t *pentKeyvalue, KeyValueData *pkvd )
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	if (mod_id == 2)//TFC
   	{
      		if (pentKeyvalue == pent_info_tfdetect)
      		{
      			if (!stricmp(pkvd->szKeyName, "team1_allies"))       // BLUE allies
				team_allies[0] = atoi(pkvd->szValue);
			else if (!stricmp(pkvd->szKeyName, "team2_allies"))  // RED allies
				team_allies[1] = atoi(pkvd->szValue);
			else if (!stricmp(pkvd->szKeyName, "team3_allies"))  // YELLOW allies
				team_allies[2] = atoi(pkvd->szValue);
			else if (!stricmp(pkvd->szKeyName, "team4_allies"))  // GREEN allies
				team_allies[3] = atoi(pkvd->szValue);
      		}
      		else if (pent_info_tfdetect == NULL 
      				&& !strcmp(pkvd->szKeyName, "classname")
      				&& !strcmp(pkvd->szValue, "info_tfdetect") )
         	{
            		pent_info_tfdetect = pentKeyvalue;
         	}
      	}
	else if (mod_id == 4 //OPFOR
			&& !is_defaultctf 
			&& !stricmp(pkvd->szKeyName, "defaultctf") 
			&& !stricmp(pkvd->szValue, "1") )
	{
		is_defaultctf 		= true;
		TeamPlayIsOn		= true;
		TeamPlayChecked		= true;
	}

	RETURN_META(MRES_HANDLED);
}


static edict_t* FindEntityByString(edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue)
{
	if (!gpGlobals->deathmatch || mod_id!=3) RETURN_META_VALUE(MRES_IGNORED, NULL);
	
	// if a new round has started, tell the bots this...
	if (strcmp(pszValue, "info_map_parameters") == 0)
	{
		NewRoundOffTime=gpGlobals->time + cvar_NewRoundOffTime->value;
	}

	RETURN_META_VALUE(MRES_HANDLED, NULL);
}


C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	if(!pFunctionTable) 
	{
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) 
	{
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	
	memset(pFunctionTable, 0, sizeof(DLL_FUNCTIONS));
	
	pFunctionTable->pfnPlayerPostThink	= PlayerPostThink;
	pFunctionTable->pfnServerDeactivate	= ServerDeactivate;
	pFunctionTable->pfnSpawn		= DispatchSpawn;
	pFunctionTable->pfnKeyValue		= DispatchKeyValue;

	return(TRUE);
}


C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) 
{
	if(!pengfuncsFromEngine) 
	{
		return(FALSE);
	}
	else if(*interfaceVersion != ENGINE_INTERFACE_VERSION) 
	{
		*interfaceVersion = ENGINE_INTERFACE_VERSION;
		return(FALSE);
	}
	
	memset(pengfuncsFromEngine, 0, sizeof(enginefuncs_t));

	pengfuncsFromEngine->pfnFindEntityByString = FindEntityByString;
	
	return TRUE;
}
