#include "playername.h"

cvar_t teamsystem1	= {"playername_teamdetection",	  "100",FCVAR_EXTDLL, 0, NULL};
cvar_t teamforcem	= {"playername_forceteammode",	  "0", 	FCVAR_EXTDLL, 0, NULL};
cvar_t pn_onhan		= {"playername_on",		  "1", 	FCVAR_EXTDLL, 0, NULL};
cvar_t vertical		= {"playername_vertical",	  "0.6",FCVAR_EXTDLL, 0, NULL};
cvar_t horizontal	= {"playername_horizontal",	  "-1",	FCVAR_EXTDLL, 0, NULL};

cvar_t ShowExtraInfo	= {"playername_extra_info",	  "1",	FCVAR_EXTDLL, 0, NULL};

cvar_t teammatesonly	= {"playername_teammates_only",   "1", 	FCVAR_EXTDLL, 0, NULL};
cvar_t fixed_team_colors= {"playername_use_team_colors",  "1", 	FCVAR_EXTDLL, 0, NULL};

cvar_t on_in_op4ctf    	= {"playername_enabled_in_op4ctf","0",	FCVAR_EXTDLL, 0, NULL};

cvar_t pausetime	= {"playername_newround_pausetime","5", FCVAR_EXTDLL, 0, NULL};
cvar_t fast_det		= {"playername_fast_cs_teamdetection","1", FCVAR_EXTDLL, 0, NULL};
cvar_t init_tfcspyfix	= {"playername_tfc_spyfix","1", 	FCVAR_EXTDLL, 0, NULL};

//HUD Text modifications
cvar_t _hud_text_fx	= {"playername_hudtext_fx",		"1", 	FCVAR_EXTDLL, 0, NULL};
cvar_t _hud_text_fadein	= {"playername_hudtext_fadein_time",	"0.2", 	FCVAR_EXTDLL, 0, NULL};
cvar_t _hud_text_fadeout= {"playername_hudtext_fadeout_time",	"0.1",	FCVAR_EXTDLL, 0, NULL};
cvar_t _hud_text_hold	= {"playername_hudtext_hold_time",	"0.75", FCVAR_EXTDLL, 0, NULL};
cvar_t _hud_text_fxtime	= {"playername_hudtext_fx_time",	"0", 	FCVAR_EXTDLL, 0, NULL};

//TFC: blue team
//CS: CT team
//DoD: allies
cvar_t tfc_team1_color = {"playername_team1_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//TFC: red team
//CS: T team
//DoD: axis
cvar_t tfc_team2_color = {"playername_team2_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//TFC: yellow team?
cvar_t tfc_team3_color = {"playername_team3_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//TFC: green team?
cvar_t tfc_team4_color = {"playername_team4_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//Friendly .. green
cvar_t friendlycolor	= {"playername_friendly_color", "0:0:0" , FCVAR_EXTDLL, 0, NULL};

//DM .. blue
cvar_t dmcolor		= {"playername_dm_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//Enemy .. red
cvar_t enemycolor	= {"playername_enemy_color", 	"0:0:0" , FCVAR_EXTDLL, 0, NULL};

//Custom Show
cvar_t enemy_extra1_style 	= {"playername_enemy_extra_style1",	"(Enemy) %name%",			FCVAR_EXTDLL , 0 , NULL};
cvar_t enemy_extra2_style 	= {"playername_enemy_extra_style2",	"(Enemy) %name% (%health%/%armor%)",	FCVAR_EXTDLL , 0 , NULL};
cvar_t friendly_extra_style 	= {"playername_friendly_extra_style",	"(Friendly) %name% (%health%/%armor%)",	FCVAR_EXTDLL , 0 , NULL};
cvar_t dm_extra_style 		= {"playername_dm_extra_style",		"%name% (%health%/%armor%)",		FCVAR_EXTDLL , 0 , NULL};

//info-for-client-and-server-browsers
cvar_t PlayerNameUserInfo = {"playername_version", VVERSION, FCVAR_EXTDLL | FCVAR_SERVER | FCVAR_UNLOGGED, 0, NULL};


void plugin_init(void) 
{
	MODCheck();
	
	LOG_MESSAGE(PLID, "%s v%s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   %s", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: " __DATE__ ", " __TIME__ " EET");
	
	CVAR_REGISTER(&pn_onhan);
	CVAR_REGISTER(&teamsystem1);
	CVAR_REGISTER(&teamforcem);
	
	if (default_showenemy_on) teammatesonly.string="0";
	CVAR_REGISTER(&teammatesonly);

	CVAR_REGISTER(&ShowExtraInfo);
	
	CVAR_REGISTER(&vertical);
	CVAR_REGISTER(&horizontal);
	
	CVAR_REGISTER(&fixed_team_colors);
	CVAR_REGISTER(&on_in_op4ctf);
	
	CVAR_REGISTER(&pausetime);
	CVAR_REGISTER(&fast_det);
	CVAR_REGISTER(&init_tfcspyfix);
	
	CVAR_REGISTER(&_hud_text_fx);
	CVAR_REGISTER(&_hud_text_fadein);
	CVAR_REGISTER(&_hud_text_fadeout);
	CVAR_REGISTER(&_hud_text_hold);
	CVAR_REGISTER(&_hud_text_fxtime);
	
	CVAR_REGISTER(&tfc_team1_color);
	CVAR_REGISTER(&tfc_team2_color);
	CVAR_REGISTER(&tfc_team3_color);
	CVAR_REGISTER(&tfc_team4_color);
	
	CVAR_REGISTER(&friendlycolor);
	CVAR_REGISTER(&enemycolor);
	CVAR_REGISTER(&dmcolor);
	
	CVAR_REGISTER(&enemy_extra1_style);
	CVAR_REGISTER(&enemy_extra2_style);
	CVAR_REGISTER(&friendly_extra_style);
	CVAR_REGISTER(&dm_extra_style);
	
	CVAR_REGISTER(&PlayerNameUserInfo);
	
	tfcspyfix	= CVAR_GET_POINTER(init_tfcspyfix.name);
	
	e_style1	= CVAR_GET_POINTER(enemy_extra1_style.name);
	e_style2	= CVAR_GET_POINTER(enemy_extra2_style.name);
	f_style1	= CVAR_GET_POINTER(friendly_extra_style.name);
	dmstyle1	= CVAR_GET_POINTER(dm_extra_style.name);
	
	teamsystem	= CVAR_GET_POINTER(teamsystem1.name);
	teamforce	= CVAR_GET_POINTER(teamforcem.name);
	pn_on		= CVAR_GET_POINTER(pn_onhan.name);
	tm_only		= CVAR_GET_POINTER(teammatesonly.name);
	
	pystytaso	= CVAR_GET_POINTER(vertical.name);
	vaakataso	= CVAR_GET_POINTER(horizontal.name);

	dm_color	= CVAR_GET_POINTER(dmcolor.name);
	enemy_color	= CVAR_GET_POINTER(enemycolor.name);
	friendly_color	= CVAR_GET_POINTER(friendlycolor.name);

	team1_color	= CVAR_GET_POINTER(tfc_team1_color.name);
	team2_color	= CVAR_GET_POINTER(tfc_team2_color.name);
	team3_color	= CVAR_GET_POINTER(tfc_team3_color.name);
	team4_color	= CVAR_GET_POINTER(tfc_team4_color.name);
	
	op4ctf_enabled	= CVAR_GET_POINTER(on_in_op4ctf.name);
	fixed_teams	= CVAR_GET_POINTER(fixed_team_colors.name);
	
	extra_info	= CVAR_GET_POINTER(ShowExtraInfo.name);
	
	cvar_NewRoundOffTime	= CVAR_GET_POINTER(pausetime.name);
	fastdetection		= CVAR_GET_POINTER(fast_det.name);
	
	hud_fx		= CVAR_GET_POINTER(_hud_text_fx.name);
	hud_fadein	= CVAR_GET_POINTER(_hud_text_fadein.name);
	hud_fadeout	= CVAR_GET_POINTER(_hud_text_fadeout.name);
	hud_hold	= CVAR_GET_POINTER(_hud_text_hold.name);
	hud_fxtime	= CVAR_GET_POINTER(_hud_text_fxtime.name);
	
	mp_teamplay	= CVAR_GET_POINTER("mp_teamplay");
}

