#ifndef PN_UTIL_H
#define PN_UTIL_H

typedef struct 
{
	unsigned r : 8;
	unsigned g : 8;
	unsigned b : 8;
} t_color;

typedef enum {
	color_Team1 = 1,
	color_Team2,
	color_Team3,
	color_Team4,
	color_Friendly,
	color_Enemy,
	color_DM,
} color_type;

//plugin.cpp
extern void plugin_init(void);

//get color by type
extern void UTIL_GetColor( t_color &color, const color_type type );

//send hudmessage to one player
extern void UTIL_SendHudMessageOne(edict_t *pEntity, const hudtextparms_t &textparms, const char *pMessage);

//find target forward from pMe
extern edict_t *UTIL_FindEntityForward( edict_t *pMe );

//detect MOD
extern void MODCheck(void);

//gets text format for different modes
extern void GetFriendlyHudText(char *HUD_Text, const unsigned HUD_Text_max, edict_t *pEntity, int extrainfo);
extern void GetEnemyHudText(char *HUD_Text, const unsigned HUD_Text_max, edict_t *pEntity, int extrainfo);
extern void GetDMHudText(char *HUD_Text, const unsigned HUD_Text_max, edict_t *pEntity, int extrainfo);

//check if game is teamplay
extern void CheckTeamPlay(void);

//gets text color for different teams
extern bool GetTeamColor(const int _mod_id, edict_t *pEntity, t_color &TextColor);

//detect if players are enemies or friends
extern bool Friendly_or_Enemy(const int teams, edict_t *pThis, edict_t *pEntity);


inline bool IsValidIndex(int index)
{
	return (index > 0 && index <= gpGlobals->maxClients);
}

inline bool IsPlayer(edict_t *pEnt)
{
	if(!pEnt) return false;
	return (GETPLAYERUSERID(pEnt)>-1);
}

inline bool IsAlive(edict_t *pEdict)
{
	if(!pEdict) return false;
	return ((pEdict->v.deadflag == DEAD_NO) && (pEdict->v.health > 0) && !(pEdict->v.flags & FL_NOTARGET));
}

inline const char *GetModel( edict_t *pEntity ) 
{
	return (g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)( pEntity ), "model"));
}

inline void UTIL_SetHudParamColors( hudtextparms_t &textparms, const t_color &color )
{
	textparms.r2 = textparms.r1 = color.r;
	textparms.g2 = textparms.g1 = color.g;
	textparms.b2 = textparms.b1 = color.b;
}

// Overloaded to add IGNORE_GLASS
inline void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE) | (ignoreGlass?0x100:0), pentIgnore, ptr );
}

inline void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE), pentIgnore, ptr );
}

inline void CVAR_DIRSET_STRING(const cvar_t *cvar, const char *str) 
{ 
	(*g_engfuncs.pfnCvar_DirectSet)((cvar_t*)cvar,(char*)str); 
}


#endif /*PN_UTIL_H*/

